﻿Imports MapControlSamples.Common
Imports System
Imports System.Collections.Generic
Imports Windows.ApplicationModel.Resources
Imports Windows.Devices.Geolocation
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Controls.Maps
Imports Windows.UI.Xaml.Navigation
Imports MapControlSamples.Models

Namespace MapControlSamples
	''' <summary>
	''' A page that displays details for a single item within a group.
	''' </summary>
	Public NotInheritable Partial Class BindingCollectionsPage
		Inherits Page

		Private ReadOnly navigationHelper_Renamed As NavigationHelper
		Private ReadOnly resourceLoader As ResourceLoader = ResourceLoader.GetForCurrentView("Resources")

		Private _teams As List(Of Team)

		Public Sub New()
			Me.InitializeComponent()

			Me.navigationHelper_Renamed = New NavigationHelper(Me)
			AddHandler Me.navigationHelper_Renamed.LoadState, AddressOf NavigationHelper_LoadState
			AddHandler Me.navigationHelper_Renamed.SaveState, AddressOf NavigationHelper_SaveState

			' setup the teams
			_teams = setupTeams()
		End Sub

		Private Function setupTeams() As List(Of Team)
            Dim teams As New List(Of Team)

			' AFC East
			teams.Add(New Team("New England Patriots", "AFC East", "Gillette Stadium", 42.090958, -71.264379))
			teams.Add(New Team("Buffalo Bills", "AFC East", "Ralph Wilson Stadium", 42.773749, -78.786604))
			teams.Add(New Team("Miami Dolphins", "AFC East", "Sun Life Stadium", 25.958038, -80.238270))
			teams.Add(New Team("New York Jets", "AFC East", "Met Life Stadium", 40.812852, -74.073781))

			' AFC West
			teams.Add(New Team("Denver Broncos", "AFC West", "Sports Authority Field", 39.744053, -105.019791))
			teams.Add(New Team("San Diego Chargers", "AFC West", "Qualcomm Stadium", 32.783917, -117.119476))
			teams.Add(New Team("Kansas City Chiefs", "AFC West", "Arrowhead Stadium", 39.048935, -94.483444))
			teams.Add(New Team("Oakland Raiders", "AFC West", "O.co Coliseum", 37.751616, -122.200224))

			' AFC North
			teams.Add(New Team("Cincinnati Bengals", "AFC North", "Paul Brown Stadium", 39.096413, -84.516583))
			teams.Add(New Team("Baltimore Ravens", "AFC North", "M&T Bank Stadium", 39.277926, -76.622232))
			teams.Add(New Team("Pittsburgh Steelers", "AFC North", "Heinz Field", 40.446761, -80.015160))
			teams.Add(New Team("Cleveland Browns", "AFC North", "FirstEnergy Stadium", 41.506074, -81.699161))

			' AFC South
			teams.Add(New Team("Indianapolis Colts", "AFC South", "Lucas Oil Stadium", 39.760058, -86.163386))
			teams.Add(New Team("Houston Texans", "AFC South", "NRG Stadium", 29.684691, -95.410450))
			teams.Add(New Team("Tennessee Titans", "AFC South", "LP Field", 36.166648, -86.770979))
			teams.Add(New Team("Jacksonville Jaguars", "AFC South", "EverBank Field", 30.324611, -81.636495))

			' NFC East
			teams.Add(New Team("Dallas Cowboys", "NFC East", "AT&T Stadium", 32.747243, -97.093979))
			teams.Add(New Team("Philadelphia Eagles", "NFC East", "Lincoln Financial Field", 39.900670, -75.166956))
			teams.Add(New Team("New York Giants", "NFC East", "Met Life Stadium", 40.813055, -74.074230))
			teams.Add(New Team("Washington Redskins", "NFC East", "FedEx Field", 38.907686, -76.865738))

			' NFC West
			teams.Add(New Team("Arizona Cardinals", "NFC West", "University of Phoenix Stadium", 33.527594, -112.262028))
			teams.Add(New Team("San Francisco 49ers", "NFC West", "Levi's Stadium", 37.403260, -121.969394))
			teams.Add(New Team("Seattle Seahawks", "NFC West", "CenturyLink Field", 47.595141, -122.331060))
			teams.Add(New Team("St. Louis Rams", "NFC West", "Edward Jones Dome", 38.632984, -90.187871))

			' NFC North
			teams.Add(New Team("Detroit Lions", "NFC North", "Ford Field", 42.339978, -83.045078))
			teams.Add(New Team("Green Bay Packers", "NFC North", "Lambeau Field", 44.501352, -88.061606))
			teams.Add(New Team("Chicago Bears", "NFC North", "Soldier Field", 41.862373, -87.616088))
			teams.Add(New Team("Minnesota Vikings", "NFC North", "TFC Bank Stadium", 44.976892, -93.224331))

			' NFC South
			teams.Add(New Team("Carolina Panthers", "NFC South", "Bank of America Stadium", 35.225652, -80.852246))
			teams.Add(New Team("New Orleans Saints", "NFC South", "Mercedes-Benz Superdome", 29.951039, -90.080727))
			teams.Add(New Team("Atlanta Falcons", "NFC South", "Georgia Dome", 33.757712, -84.400352))
			teams.Add(New Team("Tampa Bay Buccaneers", "NFC South", "Raymond James Stadium", 27.975874, -82.502776))

			Return teams
		End Function

		''' <summary>
		''' Gets the <see cref="NavigationHelper"/> associated with this <see cref="Page"/>.
		''' </summary>
        Public ReadOnly Property NavigationHelper As NavigationHelper
            Get
                Return Me.navigationHelper_Renamed
            End Get
        End Property

		''' <summary>
		''' Populates the page with content passed during navigation. Any saved state is also
		''' provided when recreating a page from a prior session.
		''' </summary>
		''' <param name="sender">
		''' The source of the event; typically <see cref="NavigationHelper"/>.
		''' </param>
		''' <param name="e">Event data that provides both the navigation parameter passed to
		''' <see cref="Frame.Navigate(Type, Object)"/> when this page was initially requested and
		''' a dictionary of state preserved by this page during an earlier
		''' session.  The state will be null the first time a page is visited.</param>
		Private Sub NavigationHelper_LoadState(ByVal sender As Object, ByVal e As LoadStateEventArgs)
			' TODO: Create an appropriate data model for your problem domain to replace the sample data.
		End Sub

		''' <summary>
		''' Preserves state associated with this page in case the application is suspended or the
		''' page is discarded from the navigation cache.  Values must conform to the serialization
		''' requirements of <see cref="SuspensionManager.SessionState"/>.
		''' </summary>
		''' <param name="sender">The source of the event; typically <see cref="NavigationHelper"/>.</param>
		''' <param name="e">Event data that provides an empty dictionary to be populated with
		''' serializable state.</param>
		Private Sub NavigationHelper_SaveState(ByVal sender As Object, ByVal e As SaveStateEventArgs)
			' TODO: Save the unique state of the page here.
		End Sub

		#Region "NavigationHelper registration"

		''' <summary>
		''' The methods provided in this section are simply used to allow
		''' NavigationHelper to respond to the page's navigation methods.
		''' <para>
		''' Page specific logic should be placed in event handlers for the  
		''' <see cref="NavigationHelper.LoadState"/>
		''' and <see cref="NavigationHelper.SaveState"/>.
		''' The navigation parameter is available in the LoadState method 
		''' in addition to page state preserved during an earlier session.
		''' </para>
		''' </summary>
		''' <param name="e">Provides data for navigation methods and event
		''' handlers that cannot cancel the navigation request.</param>
		Protected async Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
			' Call the navigation helper base function.
			Me.navigationHelper_Renamed.OnNavigatedTo(e)

			' Size the Map Control
			myMapControl.Width = Windows.UI.Xaml.Window.Current.Bounds.Width
			myMapControl.Height = Windows.UI.Xaml.Window.Current.Bounds.Height-120

			' Set the ItemsSource of the MapItemsControl.
			MapItems.ItemsSource = _teams

			' create the view bounds
            Dim positions As New List(Of BasicGeoposition)
			For Each team As Team In _teams
				positions.Add(team.StadiumLocation.Position)
			Next team

			' Get the geobounding box
			Dim box As GeoboundingBox = GeoboundingBox.TryCompute(positions)

			myMapControl.Center = New Geopoint(box.Center)

			' For some reason this function always returns false.
			Dim success As Boolean = await myMapControl.TrySetViewBoundsAsync(box, Nothing, MapAnimationKind.Default)

			' Collapse the progress bar.
			pbProgressBar.Visibility = Windows.UI.Xaml.Visibility.Collapsed
		End Sub

		Protected Overrides Sub OnNavigatedFrom(ByVal e As NavigationEventArgs)
			Me.navigationHelper_Renamed.OnNavigatedFrom(e)
		End Sub

		#End Region
	End Class
End Namespace